//
//  SSMp3Lame.h
//  SSMp3Lame
//
//  Created by Lion OS on 12-9-18.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SSMp3Lame;
@class SSMp3LameData;
@protocol SSMp3LameDelegate
-(void)SSMp3Lame:(SSMp3Lame *)sender Error:(NSString *)strErr;
-(void)SSMp3Lame:(SSMp3Lame *)sender Debug:(NSString *)debugInfo;
-(void)SSMp3Lame:(SSMp3Lame *)sender Message:(NSString *)strMsg;
@end

typedef enum{
    MP3_MODE_STEREO = 0,
    MP3_MODE_JOINT_STEREO,
    MP3_MODE_DUAL_CHANNEL,   /* Doesn't supports this! */
    MP3_MODE_MONO,
    MP3_MODE_NOT_SET,
    MP3_MODE_MAX_INDICATOR   /* Don't use this! It's used for sanity checks. */
} SSMp3LameMode;

typedef enum
{
    Mp3_Quality_Best,
    Mp3_Quality_Good,
    Mp3_Quality_Normal,
    Mp3_Quality_Low,
}SSMp3Quality;

typedef enum
{
    SSMp3EncoderTargetBitrate,
    SSMp3EncoderTargetQuality,
}SSMp3EncoderTarget;

typedef enum
{
    SSMp3EncoderEngineQualityHigh=0,
    SSMp3EncoderEngineQualityStandard,
    SSMp3EncoderEngineQualityFast,
}SSMp3EncoderEngineQuality;

typedef enum
{
    SSMp3EncoderVBRModeStandard=0,
    SSMp3EncoderVBRModeFast,
}SSMp3EncoderVBRMode;

#define SSMP3_ID3V2_COMMENT_LENGTH 2048
#define SSMP3_DEFAULT_BITRATE 128
#define SSMP3_DEFAULT_QUALITY 50
typedef struct
{
    SSMp3EncoderTarget target;
    SSMp3EncoderEngineQuality engineQuality;
    union{
        struct{
            /**
             8~320(low ~ best);
             **/
            NSInteger bitrate; /**kpbs***/
            BOOL isCBR;
        }SSMp3Bitrate;
        struct{
            /**
             0~100(low ~ best);
             **/
            NSInteger quality;  
            SSMp3EncoderVBRMode vbrMode;
        }SSMp3Quality;
    }SSTargetProperty;
}SSMP3Configure;

@interface SSMp3Lame : NSObject
{
    id<SSMp3LameDelegate> mDelegate;
    SSMp3LameData *mData;
    NSDictionary *mMeta;
    uint16_t mUTF16[SSMP3_ID3V2_COMMENT_LENGTH];
}
+(const wchar_t *)NSStringToWchar_t:(NSString *)inString outString: (wchar_t *)outString maxOutString:(NSInteger)max;
+(const uint16_t *)NSStringToUTF16:(NSString *)inString outString:(uint16_t *)outString maxOutString:(NSInteger)max;
+(void)configureMp3Encoder:(SSMP3Configure *)mp3Configure;
+(void)getDefaultConfigure:(SSMP3Configure *)mp3Configure;

-(id)initWithDelegate:(id<SSMp3LameDelegate>)delegate outFile:(NSString *)outFile;
-(id)initWithOutFile:(NSString *)outFile;
-(void)setDelegate:(id<SSMp3LameDelegate>)delegate;

-(void)setMp3lameConfigure:(SSMP3Configure *)config;
-(SSMP3Configure)getMp3lameConfigure;
-(void)setMp3ID3Tag:(NSDictionary *)meta;
/*
 *build internal interface.
 */
-(void)configurationMp3Encoder;
//set param
-(NSInteger)numbersOfChannels;
-(void)setNumbersOfChannels:(NSInteger)num;
-(NSInteger)samplerate;
-(void)setSamplerate:(NSInteger)sr;
-(NSInteger)bitrate;
-(void)setBitrate:(NSInteger)bt;
-(SSMp3LameMode)mp3Mode;
-(void)setMp3Mode:(SSMp3LameMode)md;
-(SSMp3Quality)mp3Quality;
-(void)setMp3Quality:(SSMp3Quality)mq;
-(NSString *)getOutFilePath;

//encode..
-(BOOL)readyToEncode;

//
-(BOOL)addPCMDataToEncode:(const float *)sampleData sampleCount:(NSInteger)numSample;
-(BOOL)addPCMDataToEncode_shortInt:(const short int *)sampleData sampleCount:(NSInteger)numSample;
-(BOOL)addPCMDataToEncode_int:(const int *)sampleData sampleCount:(NSInteger)numSample;
-(BOOL)addPCMDataToEncode_long:(const long *)sampleData sampleCount:(NSInteger)numSample;
-(BOOL)addPCMDataToEncode_double:(const double *)sampleData sampleCount:(NSInteger)numSample;
@end
